unit B_Dialog_Button_Nav ;

interface

uses // C&C...
     Behavior, // TBehavior
     Events ; // PEvent

type TForm_Button_Navigation_Behavior = class( TBehavior )
                                            public // API...
                                                function Allow_Normal_Processing( Event : TEvent ) : boolean ;
                                                    override ;
                                                procedure Execute( Event : TEvent ) ;
                                                    override ;
                                        end ;

implementation

uses // Borland...
     Windows, // VK_Down

     Buttons, // TSpeedButton
     Controls, // TControl
     Forms, // TForm
     StdCtrls, // TButton
     SysUtils, // uppercase
     
     // C&C...
     WinEvent ; // PWindows_Key_Down_Event


function Button_Focus( Form : TForm ) : TButton ;

var Control : TControl ;

begin
    Control := Form.ActiveControl ;
    Result := nil ;
    if( ( Control <> nil ) and ( Control is TButton ) ) then
    begin
        Result := TButton( Control ) ;
    end ;
end ;


function Speed_Button_Focus( Form : TForm ) : TSpeedButton ;

var Loop : integer ;

begin
    Result := nil ;
    for Loop := 0 to Form.ControlCount - 1 do
    begin
        if( Form.Controls[ Loop ] is TSpeedButton ) then
        begin
            if( not TSpeedButton( Form.Controls[ Loop ] ).Flat ) then
            begin
                Result := TSpeedButton( Form.Controls[ Loop ] ) ;
                exit ;
            end ;
        end ;
    end ;
end ;


procedure Clear_Button_Focus( Form : TForm ) ;

var Button : TSpeedButton ;

begin
    Button := Speed_Button_Focus( Form ) ;
    if( Button <> nil ) then
    begin
        Button.Flat := True ;
    end ;
end ;


// TForm_Button_Navigation_Behavior methods...

// API...

function TForm_Button_Navigation_Behavior.Allow_Normal_Processing( Event : TEvent ) : boolean ;

var BFocus : TButton ;
    E : TWindows_Key_Down_Event ;
    Form : TForm ;
    SFocus : TSpeedButton ;

    procedure Find_Next_Button( Dummy : integer ) ;

    var Button : TButton ;
        Loop : integer ;
        MinMax : integer ;
        SButton : TSpeedButton ;

    begin
        MinMax := 32767 ;
        BFocus := nil ;
        SFocus := nil ;
        for Loop := 0 to Form.ControlCount - 1 do
        begin
            if( ( Form.Controls[ Loop ] is TButton ) and ( Form.Controls[ Loop ].Visible ) ) then
            begin
                Button := TButton( Form.Controls[ Loop ] ) ;
                if( ( Button.Top > Dummy ) and ( Button.Top < MinMax ) ) then
                begin
                    MinMax := Button.Top ;
                    BFocus := Button ;
                    SFocus := nil ;
                end ;
            end ;
            if( ( Form.Controls[ Loop ] is TSpeedButton ) and ( Form.Controls[ Loop ].Visible ) ) then
            begin
                SButton := TSpeedButton( Form.Controls[ Loop ] ) ;
                if( ( SButton.Top > Dummy ) and ( SButton.Top < MinMax ) ) then
                begin
                    MinMax := SButton.Top ;
                    SFocus := SButton ;
                    BFocus := nil ;
                end ;
            end ;
        end ; // for Loop := 0 to ControlCount - 1
        Clear_Button_Focus( Form ) ;
    end ;


    procedure Find_Previous_Button( Dummy : integer ) ;

    var Button : TButton ;
        Loop : integer ;
        MinMax : integer ;
        SButton : TSpeedButton ;

    begin
        MinMax := 0 ;
        BFocus := nil ;
        SFocus := nil ;
        for Loop := 0 to Form.ControlCount - 1 do
        begin
            if( ( Form.Controls[ Loop ] is TButton ) and ( Form.Controls[ Loop ].Visible ) ) then
            begin
                Button := TButton( Form.Controls[ Loop ] ) ;
                if( ( Button.Top < Dummy ) and ( Button.Top > MinMax ) ) then
                begin
                    MinMax := Button.Top ;
                    BFocus := Button ;
                    SFocus := nil ;
                end ;
            end ;
            if( ( Form.Controls[ Loop ] is TSpeedButton ) and ( Form.Controls[ Loop ].Visible ) ) then
            begin
                SButton := TSpeedButton( Form.Controls[ Loop ] ) ;
                if( ( SButton.Top < Dummy ) and ( SButton.Top > MinMax ) ) then
                begin
                    MinMax := SButton.Top ;
                    SFocus := SButton ;
                    BFocus := nil ;
                end ;
            end ;
        end ; // for Loop := 0 to ControlCount - 1
        Clear_Button_Focus( Form ) ;
    end ;

var Button : TButton ;
    Dummy : integer ;
    Loop : integer ;
    S : string ;
    SButton : TSpeedButton ;

begin
    // Setup...
    Result := True ;
    if( ( Event = nil ) or ( Event.Event_Type <> EID_Windows_Key_Down ) ) then
    begin
        exit ;
    end ;
    E := TWindows_Key_Down_Event( Event ) ;
    Form := TForm( E.Source ) ;

    // Process key
    if( E.Key = VK_RETURN ) then
    begin
        SFocus := Speed_Button_Focus( Form ) ;
        if( SFocus <> nil ) then
        begin
            SFocus.OnClick( SFocus ) ;
            Result := False ;
        end ;
    end else
    if( ( E.Key = VK_DOWN ) or ( E.Key = VK_TAB ) ) then
    begin
        Result := False ;
        BFocus := Button_Focus( Form ) ;
        if( BFocus <> nil ) then
        begin
            Dummy := BFocus.Top ;
        end else
        begin
            SFocus := Speed_Button_Focus( Form ) ;
            if( SFocus = nil ) then
            begin
                Dummy := 0 ;
            end else
            begin
                Dummy := SFocus.Top ;
            end ;
        end ; // if( BFocus <> nil )
        Find_Next_Button( Dummy ) ;
        if( BFocus <> nil ) then
        begin
            BFocus.SetFocus ;
        end else
        if( SFocus <> nil ) then
        begin
            SFocus.Flat := False ;
        end else
        begin // Ran off end of dialog, wrap to beginning
            Find_Next_Button( 0 ) ;
            if( BFocus <> nil ) then
            begin
                BFocus.SetFocus ;
            end else
            if( SFocus <> nil ) then
            begin
                SFocus.Flat := False ;
            end ;
        end ;
    end else
    if( E.Key = VK_UP ) then
    begin
        Result := False ;
        BFocus := Button_Focus( Form ) ;
        if( BFocus <> nil ) then
        begin
            Dummy := BFocus.Top ;
        end else
        begin
            SFocus := Speed_Button_Focus( Form ) ;
            if( SFocus = nil ) then
            begin
                Dummy := 32767 ;
            end else
            begin
                Dummy := SFocus.Top ;
            end ;
        end ; // if( BFocus <> nil )
        Find_Previous_Button( Dummy ) ;
        if( BFocus <> nil ) then
        begin
            BFocus.SetFocus ;
        end else
        if( SFocus <> nil ) then
        begin
            SFocus.Flat := False ;
        end else
        begin // Ran off end of dialog, wrap to beginning
            Find_Previous_Button( 32767 ) ;
            if( BFocus <> nil ) then
            begin
                BFocus.SetFocus ;
            end else
            if( SFocus <> nil ) then
            begin
                SFocus.Flat := False ;
            end ;
        end ;
    end else
    begin
        // See if pressed key matches accelerator for button.  If found, activate button
        for Loop := 0 to Form.ControlCount - 1 do
        begin
            if( ( Form.Controls[ Loop ] is TButton ) and ( Form.Controls[ Loop ].Visible ) ) then
            begin
                Button := TButton( Form.Controls[ Loop ] ) ;
                S := Button.Caption ;
                Dummy := pos( '&', S ) ;
                if( Dummy <> 0 ) then
                begin
                    S := uppercase( copy( S, Dummy + 1, 1 ) ) ;
                    if( S = chr( E.Key ) ) then
                    begin
                        Result := False ;
                        Button.OnClick( Button ) ;
                        exit ;
                    end ;
                end ;
            end ; // if( Controls[ Loop ] is TButton )
            if( ( Form.Controls[ Loop ] is TSpeedButton ) and ( Form.Controls[ Loop ].Visible ) ) then
            begin
                SButton := TSpeedButton( Form.Controls[ Loop ] ) ;
                S := SButton.Caption ;
                Dummy := pos( '&', S ) ;
                if( Dummy <> 0 ) then
                begin
                    S := uppercase( copy( S, Dummy + 1, 1 ) ) ;
                    if( S = chr( E.Key ) ) then
                    begin
                        Result := False ;
                        SButton.OnClick( SButton ) ;
                        exit ;
                    end ;
                end ;
            end ; // if( Controls[ Loop ] is TSpeedButton )
        end ; // for Loop := 0 to ControlCount - 1
    end ;
end ; // TForm_Button_Navigation_Behavior.Allow_Normal_Processing


procedure TForm_Button_Navigation_Behavior.Execute( Event : TEvent ) ;

begin
    // This routine left intentionally blank
end ;



end.

