{
        Program Name : Button_2D
        Package Name : LB
        Purpose      : 2-D GUI Button
        Institution  : Conroy & Conroy Co.
        Date Written : 13-Nov-2006
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2006 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          Implements a GUI button in 2D.  The main purpose of this class is to
        virtualize access to the Glyph property of TSpeedButton.
}

unit Button_2D ;

interface

uses // Borland...
     Buttons, // TSpeedButton
     Graphics ; // TBitmap

type T2D_Button = class( TSpeedButton )
                    protected // Property handlers...
                        function Get_Glyph : TBitmap ;
                            virtual ; // Always returns a copy of the glyph
                        procedure Set_Glyph( Value : TBitmap ) ; virtual ;

                    public // API...
                        property Glyph : TBitmap
                            read Get_Glyph
                            write Set_Glyph ;

                        function Glyph_Height : integer ; virtual ;

                        function Glyph_Width : integer ; virtual ;

                        procedure Paint ; override ;
                end ; // T2D_Button

implementation

// T2D_Button methods...

// Property handlers...

function T2D_Button.Get_Glyph : TBitmap ;

begin
    Result := TBitmap.Create ;
    Result.Assign( inherited Glyph ) ;
end ;


procedure T2D_Button.Set_Glyph( Value : TBitmap ) ;

begin
    inherited Glyph := Value ;
end ;


// API...

function T2D_Button.Glyph_Height : integer ;

begin
    Result := inherited Glyph.Height ;
end ;


function T2D_Button.Glyph_Width : integer ;

begin
    Result := inherited Glyph.Width ;
end ;


procedure T2D_Button.Paint ;

begin
    inherited Paint ;
end ;


end.
