/* 
        Program Name : CACHE
        Package Name : LB
        Purpose      : Cache control routines
        Institution  : Conroy & Conroy Co.
        Date Written : 18-Jun-1994
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 1994 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  These functions provide a means of coordinating several different
	caches.
*/

/* Cache handlers are passed a size (Siz) to free.  If size is zero (0) then
   Code indicates a special operation to perform.  For now, the only defined
   code is 0, which indicates that the function should return the amount of
   memory currently allocated in its cache.  If Size is not zero, Code is
   ignored.  If size is negative, then the cache should be completly zeroed.
   Other functions may be added later. */
struct TCache_Record
{
    void (*Routine)(int, int) ;
    long int Priority ;
    struct TCache_Record *Next ;
} ;


void Add_Handler( void (*Routine)(int, int), long int Priority );
/* This routine adds a cache handler to the cache chain.  Routine is a pointer
   to the cache handler and Priority is the relative priority of this cache.
   The cache list is kept in ascending order by priority to make our job
   easier later. */


void Delete_Handler( void (*Routine)(int, int) );
/* This routine removes a cache handler from the cache handler list. */


void Free_Cache( long int Siz, long int Priority, void (*Exclude)(int, int) );
/* This routine calls the appropriate cache handlers to free up Siz bytes
   of memory.  A specific handler can be excluded from this.  Calling this
   with Exclude of NULL, priority of maxint, and Siz of -1, will zero all
   caches. */
