{$N+}
{
              Program Name : FSError
              Package Name : LB
              Purpose      : File system error routines and constants
              Institution  : COnroy & Conroy Company
              Date Written : 22-Jan-95
              Written By   : Alan Conroy
              Version      : 1.0

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          This unit defines TFile_System error codes.

}

unit FSError ;

interface

const FSErr_Facility = 3 ;
      FSErr_Success = 0 ; { FS operation completed successfully }
      FSErr_FileNotOpen = 1 ; { I/O operation on unopened channel }
      FSErr_FileNotFound = 2 ; { File lookup failed }
      FSErr_EndOfFile = 3 ; { Attempt to read/seek past end of file }
      FSErr_FileNameLength = 4 ; { Error in size of file name }
      FSErr_FileName = 5 ; { Error in file name contents }
      FSErr_DirectoryNotFound = 6 ; { Directory lookup failed }
      FSErr_InvalidPath = 7 ; { Path contained reference to non-directory }
      FSErr_NoRoomOnDevice = 8 ; { Device has no room }
      FSErr_ProtectionViolation = 9 ; { Operation is not allowed }
      FSErr_DirectoryExists = 10 ; { Directory already exists }
      FSErr_FileNotEmpty = 11 ; { File is not empty }
      FSErr_DirectoryNotEmpty = 12 ; { Directory is not empty }
      FSErr_CorruptedFileStructure = 13 ; { File structure corruption found }
      FSErr_FileExists = 14 ; { File already exists }
      FSErr_IllegalOperationType = 15 ; { Illegal operation for file type }
      FSErr_LineTooLong = 16 ; { Text line is too long }
      FSErr_InvalidDevice = 17 ; { Invalid device }
      FSErr_Internal_Duplicate = 18 ; { Duplicate items encountered in tree }
      FSErr_Invalid_Open_Mode = 19 ;
      FSErr_Unsupported_Operation = 20 ; { Attempt to initialize a non-FS }
      FSErr_Device_In_Use = 21 ; { Attempt to initialize open FS }
      FSErr_Unknown_Device_Type = 22 ; { Attempt to perform an operation on a unknown type of device }
      FSErr_Internal_Error_On_Add = 23 ;
      FSErr_Invalid_Record_Size = 24 ; { Attempt to open file with invalid record size }
      FSErr_Internal_Corruption = 25 ; { File is corrupted }
      FSErr_Timeout = 26 ; { Timeout occurred while waiting for a lock }
      FSErr_Invalid_Handle = 27 ; { Invalid file handle referenced }
      FSErr_Data_Format_Error = 28 ; { Data format error }
      FSErr_Read_Only = 29 ; { File system is read-only }

function FS_Error( X : longint ) : string ;

implementation

{$I EDEFINES.INC}

uses { Borland... }
{$IFDEF DELPHI}
     SysUtils,
{$ELSE}
     Strings, { strpas }
{$ENDIF}

     { Conroy & Conroy Co. }
     ErrMastr, { Error_Code }
     _UEHDefs ; { TUEC }

function FS_Error( X : longint ) : string ; { Return error text }

var
{$IFDEF DELPHI}
    R : tUEC ;
{$ELSE}
    R : double ;
{$ENDIF}
    UEC : tUEC ;

begin
    R := Error_Code( FSErr_Facility, X ) ;
    UEC := tUEC( R ) ;
    FS_Error := strpas( Get_Error_Text( UEC, -1 ) ) ;
end ;


end.
