{$N+}
{$E+}
{
       Program Name    : Outline_Edit
       Package Name    : LB
       Purpose         : Outline editor
       Institution     : Conroy & Conroy Company
       Date written    : 27-Aug-2003
       Written by      : Alan Conroy
       Version         : 1.0

       Copyright (C) 2003 by Alan Conroy.  Released to the public domain.

       TO THE GLORY OF GOD THROUGH JESUS CHRIST

       *******************************************************
       *                                                     *
       *       M O D I F I C A T I O N   H I S T O R Y       *
       *                                                     *
       *       DATE    BY      REASON                        *
       *                                                     *
       *                                                     *
       *******************************************************

       *******************************************************
       *                                                     *
       *       P R O G R A M   P U R P O S E                 *
       *                                                     *
       *******************************************************

         This dialog is a generic outline editor.
}

unit Outline_Edit ;

interface

uses // Borland...
     Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
     Dialogs, ExtCtrls, ComCtrls,
     Buttons, // TSpeedButton
     StdCtrls,

     // C&C...
     Outlines ; // PSOutline

type
  TOutline_Editor = class(TForm)
                        Button_Panel: TPanel;
                        Tree_View: TTreeView;
                        OK_Button: TBitBtn;
                        Cancel_Button: TBitBtn;
                        Delete_Button: TSpeedButton;
                        Rename_Button: TSpeedButton;
                        Add_Button: TSpeedButton;
                        Create_Button: TSpeedButton;
                        Move_Button: TSpeedButton;
                        procedure FormKeyDown(Sender: TObject; var Key: Word;
                            Shift: TShiftState);

                        private // Instance data...
                            _Outline : PSOutline ;

                        protected // Property handlers...
                            procedure Set_Outline( O : PSOutline ) ;

                        protected // Instance support
                            function Can_Delete( Node : TTreeNode ) : boolean ;
                                virtual ;

                        public // API...
                            property Outline : PSOutline
                                read _Outline
                                write Set_Outline ;

                            procedure Refresh ; virtual ;
                    end ; // TOutline_Editor

var Outline_Editor : TOutline_Editor = nil ;

implementation

{$R *.dfm}

// TOutline_Editor methods...

procedure TOutline_Editor.FormKeyDown(Sender: TObject; var Key: Word;
    Shift: TShiftState);

begin
    if( Key = VK_Delete ) then
    begin
        if( Tree_View.Selected <> nil ) then
        begin
            if( not Can_Delete( Tree_View.Selected ) ) then
            begin
                exit ;
            end ;
            Key := 0 ;
            dispose( PSOutline_Node( Tree_View.Selected.Data ), Done ) ;
            Tree_View.Selected.Delete ;
        end ;
    end ;
end ;


// Property handlers...

procedure TOutline_Editor.Set_Outline( O : PSOutline ) ;

begin
    _Outline := O ;
    Refresh ;
end ;


// Instance support...

function TOutline_Editor.Can_Delete( Node : TTreeNode ) : boolean ;

begin
    Result := True ; // Always allow deletion byt default
end ;


// API...

procedure TOutline_Editor.Refresh ;

    procedure Process_Node( Node : PSOutline_Node ; TNode : TTreeNode ) ;

    var Loop : integer ;
        _Node : PSOutline_Node ;
        _TNode : TTreeNode ;

    begin
        for Loop := 0 to Node.Count - 1 do
        begin
            _Node := _Outline.Get_Child( Node, Loop ) ;
            _TNode := Tree_View.Items.Add( TNode, _Node.Text ) ;
            _TNode.Data := _Node ;
            Process_Node( _Node, _TNode ) ;
        end ;
    end ;

var Loop : integer ;
    Node : PSOutline_Node ;
    TNode : TTreeNode ;

begin
    Tree_View.Items.Clear ;
    if( _Outline = nil ) then
    begin
        exit ;
    end ;

    // Load treeview from outline...
    for Loop := 0 to _Outline.Count - 1 do
    begin
        Node := _Outline.Get_Child( nil, Loop ) ;
        TNode := Tree_View.Items.Add( nil, Node.Text ) ;
        TNode.Data := Node ;
        Process_Node( Node, TNode ) ;
    end ;
end ;


end.

