{
        Program Name : WinEvent
        Package Name : LB
        Purpose      : Windows event objects
        Institution  : Conroy & Conroy Co.
        Date Written : 18-July-2004
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2004 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit contains TEvent descendants which are used to indicate
        MS Windows events.
        is the base class for event objects which are used to pass
        event notifications between objects.
}

unit WinEvent ;

interface

uses // Borland...
     Classes, // Create_Windows_Key_Down_Event

     // C&C...
     Events ; // TEvent

type TSWindows_Event = object( TSEvent )
                          public // API...
                              function Name : string ; virtual ; // Name of event
                      end ;
     PSWindows_Event = ^TSWindows_Event ;

     TSWindows_Key_Down_Event = object( TSWindows_Event )
                                   public // API...
                                       Key : word ;
                                       Shift_State : TShiftState ;

                                       function Name : string ; virtual ;
                               end ;
     PSWindows_Key_Down_Event = ^TSWindows_Key_Down_Event ;


     TWindows_Event = class( TEvent )
                          public // API...
                              function Name : string ; override ; // Name of event
                      end ;

     TWindows_Key_Down_Event = class( TWindows_Event )
                                   public // API...
                                       Key : word ;
                                       Shift_State : TShiftState ;

                                       function Name : string ; override ;
                               end ;

     TWindows_Mouse_LButton_Click_Event = class( TWindows_Event )
                                              public // API...
                                                  Count : integer ;

                                                  function Name : string ; override ;
                                          end ;

     TWindows_Resize_Event = class( TWindows_Event )
                                 public // API...
                                     function Name : string ; override ;
                             end ;

// Unit API...

function Create_Windows_Key_Down_Event( Source : pointer ; Key : word ;
    Shift_State : TShiftState ) : TWindows_Key_Down_Event ;
function Create_Windows_Mouse_LButton_Click( Source : pointer ; Count : integer ) : TWindows_Mouse_LButton_Click_Event ;

implementation

// Unit API...

function Create_Windows_Key_Down_Event( Source : pointer ; Key : word ;
    Shift_State : TShiftState ) : TWindows_Key_Down_Event ;

begin
    Result := TWindows_Key_Down_Event.Create ;
    Result.Source := Source ;
    Result.Key := Key ;
    Result.Shift_State := Shift_State ;
    Result.Event_Type := EID_Windows_Key_Down ;
    Result.User := True ;
end ;


function Create_Windows_Mouse_LButton_Click( Source : pointer ; Count : integer ) : TWindows_Mouse_LButton_Click_Event ;

begin
    Result := TWindows_Mouse_LButton_Click_Event.Create ;
    Result.Source := Source ;
    Result.Count := Count ;
    Result.Event_Type := EID_Windows_Mouse_LButton_Click ;
    Result.User := True ;
end ;


// TSWindows_Event methods..

// API...

function TSWindows_Event.Name : string ;

begin
    Name := 'Abstract Windows Event' ;
end ;



// TSWindows_Key_Down_Event methods...

// API...

function TSWindows_Key_Down_Event.Name : string ;

begin
    Result := 'Windows Key Down Event' ;
end ;


// TWindows_Event methods..

// API...

function TWindows_Event.Name : string ;

begin
    Name := 'Abstract Windows Event' ;
end ;



// TWindows_Key_Down_Event methods...

// API...

function TWindows_Key_Down_Event.Name : string ;

begin
    Result := 'Windows Key Down Event' ;
end ;



// TWindows_Mouse_LButton_Click_Event methods...

// API...

function TWindows_Mouse_LButton_Click_Event.Name : string ;

begin
    Result := 'Windows Left Button Click' ;
end ;



// TWindows_Resize_Event methods...

// API...

function TWindows_Resize_Event.Name : string ;

begin
    Result := 'Windows Resize' ;
end ;


end.

