{
        Program Name : AEL
        Package Name : Subroutine Library - Layer 1
        Purpose      : Abstract Application Event Logger
        Institution  : Conroy & Conroy Co.
        Date Written : 31-January-2003
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2003 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          The classes in this unit are used to provide an OO event logging
	interface.
}

unit _AEL ;

interface

uses Common, { TBase_Object }
     ComInter, { TCommon_COM_Interface }
     _DebugIn ; { PDebug_Interface }

{$I EDEFINES.INC}

{$IFDEF DELPHI}
type TApplication_Event_Logger = class( TBase_Delphi_Object )
                                     public { API... }
					 procedure Log_Event( const S : string ) ;
					     virtual ; abstract ;
					 procedure Trace_Enter( const S : string ) ;
					     virtual ; abstract ;
					 procedure Trace_Exit( const S : string ) ;
					     virtual ; abstract ;
                                 end ;

type TCOM_Application_Event_Logger = class( TCommon_COM_Interface )
                                         public { API... }
                                             procedure Log_Event( S : PChar ) ;
                                                 virtual ; stdcall ; abstract ;
                                             procedure Trace_Enter( S : PChar ) ;
                                                 virtual ; stdcall ; abstract ;
                                             procedure Trace_Exit( S : PChar ) ;
                                                 virtual ; stdcall ; abstract ;
                                     end ;
{$ENDIF}

type TSApplication_Event_Logger = object( TBase_Object )
				     public { Constructors and destructors... }
					 constructor Init ;

                                     public { API... }
                                         function Debugger : PSDebug_Interface ;
                                             virtual ;
					 procedure Log_Event( const S : string ) ;
					     virtual ;
					 procedure Trace_Enter( const S : string ) ;
					     virtual ;
					 procedure Trace_Exit( const S : string ) ;
					     virtual ;
                                 end ;
     PSApplication_Event_Logger = ^TSApplication_Event_Logger ;

implementation

{ TApplication_Event_Logger methods... }

{ Constructors and destructors... }

constructor TSApplication_Event_Logger.Init ;

begin
    { Default does nothing }

    inherited Init ;
end ;


{ API... }

function TSApplication_Event_Logger.Debugger : PSDebug_Interface ;

begin
    Debugger := nil ;
end ;


procedure TSApplication_Event_Logger.Log_Event( const S : string ) ;

begin
    { Default does nothing }
end ;


procedure TSApplication_Event_Logger.Trace_Enter( const S : string ) ;

begin
    { Default does nothing }
end ;


procedure TSApplication_Event_Logger.Trace_Exit( const S : string ) ;

begin
    { Default does nothing }
end ;


end.
