{
        Program Name : EBCDICs
        Package Name : LB
        Purpose      : EBCDIC support
        Institution  : Conroy & Conroy Co.
        Date Written : 27-March-2001
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2001-2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit supports EBCDIC character formatting.
}

unit EBCDICs ;

interface

var EBCDIC : array[ 0..255 ] of Char ;

function To_EBCDIC( const S : string ) : string ; { Convert an ASCII string to EBCDIC }
function From_EBCDIC( const S : string ) : string ; { Convert an EBCDIC string to ASCII }
function Valid_EBCDIC( const S : string ) : boolean ;


implementation

var EBCDIC_String : string ;

function From_EBCDIC( const S : string ) : string ;

var Loop : integer ;
    Res : string ;

begin
    Res := '' ;
    for Loop := 1 to length( S ) do
    begin
        Res := Res + EBCDIC[ ord( S[ Loop ] ) ] ;
    end ;
    From_EBCDIC := Res ;
end ;


function To_EBCDIC( const S : string ) : string ; { Convert an ASCII string to EBCDIC }

var Loop : integer ;
    Res : string ;

begin
    Res := '' ;
    for Loop := 1 to length( S ) do
    begin
        Res := Res + chr( pos( S[ Loop ], EBCDIC_String ) ) ;
    end ;
    To_EBCDIC := Res ;
end ;


function Valid_EBCDIC( const S : string ) : boolean ;

var Loop : integer ;

begin
    Valid_EBCDIC := True ;
    for Loop := 1 to length( S ) do
    begin
        if( pos( S[ Loop ], EBCDIC_String ) = 0 ) then
        begin
            Valid_EBCDIC := False ;
            exit ;
        end ;
    end ;
end ;


procedure Init_Unit ;

var A : integer ;

begin
    { Build EBCDIC array }
    fillchar( EBCDIC, sizeof( EBCDIC ), 32 ) ;
    EBCDIC_String := '[.<(+!&         ]$*);^-\         ,%_>?         :#@' + Chr( 39 ) +
        '=" ABCDEFGHI       JKLMNOPQR       STUVWXYZ                       ' +
        'ABCDEFGHI       JKLMNOPQR     \  STUVWXYZ      0123456789' ;
    for A := 1 to 174 do EBCDIC[ A + 73 ] := EBCDIC_String[ A ] ;
    setlength( EBCDIC_String, 256 ) ;
    move( EBCDIC, EBCDIC_String[ 1 ], 256 ) ;
end ;


begin
    Init_Unit ;
end.
