.RADIX  10
.8086

;              Program Name : EXTRACT
;              Package Name : LB
;              Purpose      : Extract characters from buffer
;              Institution  : Conroy & Conroy Company.
;              Date Written : 04-Apr-86
;              Written By   : Alan Conroy
;              Version      : 9.2-10
;
;	 Copyright (C) 1986 by Alan Conroy.  Released to the public domain.
;
;	 TO THE GLORY OF GOD THROUGH JESUS CHRIST
;
;        *********************************************************
;        *                                                       *
;        *        M O D I F I C A T I O N   H I S T O R Y        *
;        *                                                       *
;        *     DATE      BY             REASON                   *
;        *                                                       *
;        *********************************************************
;
;        *********************************************************
;        *                                                       *
;        *           P R O G R A M   P U R P O S E               *
;        *                                                       *
;        *********************************************************
;
;   This routine extracts the characters in Workbuff, placing them in Inbuf
; and setting the length of Inbuf.  It begins at position CL in Workbuff.
; (io.asm required)
;

EXTRACT:
        PUSH AX ; Save registers
        PUSH BX
        PUSH CX
        PUSH DX
        PUSH DI
        PUSH SI
        PUSHF
        MOV  DL, 0 ; Number of bytes transferred
        MOV  AH, 0
        MOV  CH, 0
        MOV  SI, OFFSET WorkBLen
        MOV  AL, [SI] ; Get length of Workbuff
        MOV  SI, OFFSET WorkBuff
        ADD  AX, SI ; Get ending address of string in WorkBuff
        MOV  DI, OFFSET InBuff+1
        ADD  SI, CX ; Begin at position CL in input string
Extract1:
        CMP  AX, SI ; Are we at the end yet?
        JL   Extract0 ; Yes
        INC  DL ; Increment length count
        MOV  BH, [SI] ; Get byte
        MOV  [DI], BH ; Write byte
        INC  SI ; Move to next character
        INC  DI
        JMP  Extract1 ; Go back for next byte
Extract0:
        MOV  DI, OFFSET InBLen
        MOV  [DI], DL ; Store length
        POPF    ; Restore registers
        POP  SI
        POP  DI
        POP  DX
        POP  CX
        POP  BX
        POP  AX
        RET     ; All done!

	END
