/*
        Program Name : Heap.h
        Package Name : LB
        Purpose      : Heap support
        Institution  : Conroy & Conroy Co.
        Date Written : 4-Jan-1995
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (c) 1995 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  TAllocator pure virtual class and TMemory definition.

*/

class TAllocator  /* Abstract class */
{

public:
	virtual ~TAllocator() {} ; /* Finish up access */
	virtual long int Allocate( long int Size ) = 0 ; /* Allocate space */
	virtual void Deallocate( long int PTR, long int Size ) = 0 ;
	/* Deallocate space */
	virtual void Read_Heap( long int PTR, long int Size, void *Buffer ) = 0 ;
	/* Read data */
	virtual void Write_Heap( long int PTR, long int Size, void *Buffer ) = 0 ;
	/* Write data */
	virtual long int SpaceAvail() = 0 ;
	virtual long int MaxSpace() = 0 ;

} ;


class TMemory : public TAllocator
{

public:
	virtual ~TMemory() {} ; /* Finish up access */
	virtual long int Allocate( long int Size ) ; /* Allocate space */
	virtual void Deallocate( long int PTR, long int Size ) ;
	/* Deallocate space */
	virtual void Read_Heap( long int PTR, long int Size, void *Buffer ) ;
	/* Read data */
	virtual void Write_Heap( long int PTR, long int Size, void *Buffer ) ;
	/* Write data */
	virtual long int SpaceAvail() ;
	virtual long int MaxSpace() ;
} ;

#define True -1
#define False 0
