/*
        Program Name : Randoms
        Package Name : LB
        Purpose      : Generate random numbers
        Institution  : Conroy & Conroy Co.
        Date Written : 30-Dec-1998
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 1998 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	These classes are used to generate random numbers.
*/

#include "randoms.h"

int TRNG::Generate() // Generate a new random value
{
    _X = ( 0x0BB40E62D * _X + 1 ) ;
    int X = ( _X >> 1 ) & 0x7FFFFFFF;
    return X;
} ;


void TRNG::Randomize() // Randomize X
{
    randomize() ;
    _X = random( 65535 ) ;
    _X = ( _X * 65536 ) | random( 65535 ) ;
} ;


void TRNG::Set_X( int _X_ ) // Set X
{
    _X = _X_ ;
} ;


int TRNG::X() // Return X
{
    return _X ;
} ;


unsigned char TRNG8::Generate() // Generate a new random value
{
    _X = ( 29 * _X + 1 ) ;
    int X = ( _X >> 1 ) & 127;
    return X ;
} ;


void TRNG8::Randomize() // Randomize X
{
    randomize() ;
    _X = random( 265 ) ;
} ;


void TRNG8::Set_X( unsigned char _X_ ) // Set X
{
    _X = _X_ ;
} ;


unsigned char TRNG8::X() // Return X
{
    return _X ;
} ;


unsigned short TRNG16::Generate() // Generate a new random value
{
    _X = ( 31413 * _X + 1 ) ;
    int X = ( _X >> 1 ) & 32767;
    return X ;
} ;


void TRNG16::Randomize() // Randomize X
{
    randomize() ;
    _X = random( 65535 ) ;
} ;


void TRNG16::Set_X( unsigned short _X_ ) // Set X
{
    _X = _X_ ;
} ;


unsigned short TRNG16::X() // Return X
{
    return _X ;
} ;


unsigned long TRNG32::Generate() // Generate a new random value
{
    _X = ( 3141592621 * _X + 1 ) ;
    int X = ( _X >> 1 ) & 0x7FFFFFFF;
    return X ;
} ;


void TRNG32::Randomize() // Randomize X
{
    randomize() ;
    _X = random( 65535 ) ;
    _X = ( _X * 65536 ) | random( 65535 ) ;
} ;


void TRNG32::Set_X( unsigned long _X_ ) // Set X
{
    _X = _X_ ;
} ;


unsigned long TRNG32::X() // Return X
{
    return _X ;
} ;

