{
              Program Name : Weather
              Package Name : LB
              Purpose      : Determine wind-chill factor
              Institution  : Conroy & Conroy Company
              Date Written : 31-May-87
              Written By   : Alan Conroy
              Version      : 1.0

	      Copyright (c) 1987 by Alan Conroy.  Released to the Public Domain.

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          Determine wind-chill factor (in oF).
}

unit Weather ;

interface

function Wind( Speed, Temperature : Real ) : Real ;

implementation 

function Wind( Speed, Temperature : Real ) : Real ;
{ Wind chill factor depends on wind speed (in MPH) and ambient temperature (in
  Farenheit. }

begin
    Wind := ( ( ( 10.45 + ( 6.686112 * Sqrt( Speed ) ) - ( 0.447041 * Speed ) ) / 22.034 ) * ( Temperature - 91.4 ) ) + 91.4 ;
end ;



end.
