unit Video_Options_Form ;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Spin;

type
  TVideo_Options_Dialog = class(TForm)
    Button_Panel: TPanel;
    OK_Button: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Margin: TSpinEdit;
    Cursor_Rate: TSpinEdit;
    Rows: TSpinEdit;
    Columns: TSpinEdit;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Windows_Font: TComboBox;
    Filename: TEdit;
    Browse_Button: TSpeedButton;
    OpenDialog1: TOpenDialog;
    procedure RowsChange(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Browse_ButtonClick(Sender: TObject);
  private
    Font_List : TStringList ;
  public
    Current_Font : string ;
  end;

var Video_Options_Dialog : TVideo_Options_Dialog ;

implementation

{$R *.dfm}

function CB_FontEnum( LogFont : pLogFont ; TextMetric : pTextMetric ;
    Typ, Context : integer ) : integer ; far ; stdcall ;


begin
    Video_Options_Dialog.Font_List.Add( LogFont^.lfFaceName ) ;
    Result := -1 ; // Don't interrupt the iteration
end ;


procedure TVideo_Options_Dialog.RowsChange( Sender : TObject ) ;

begin
    if( Rows.Value * Columns.Value > 32768 ) then
    begin
        OK_Button.Enabled := False ;
    end else
    begin
        OK_Button.Enabled := True ;
    end ;
    if( RadioButton1.Checked and ( not FileExists( Filename.Text ) ) ) then
    begin
        OK_Button.Enabled := False ;
    end ;
end ;


procedure TVideo_Options_Dialog.RadioButton1Click( Sender : TObject ) ;

begin
    Filename.Enabled := RadioButton1.Checked ;
    Browse_Button.Enabled := RadioButton1.Checked ;
    Windows_Font.Enabled := RadioButton2.Checked ;
    RowsChange( nil ) ;
end ;


procedure TVideo_Options_Dialog.FormShow( Sender : TObject ) ;

var DC : HDC ;

begin
    Font_List := TStringList.Create ;
    DC := GetDC( Handle ) ;
    EnumFonts( DC, nil, @CB_FontEnum, nil ) ;
    ReleaseDC( Handle, DC ) ;
    Windows_Font.Items.Assign( Font_List ) ;
    Font_List.Free ;
    Windows_Font.ItemIndex := Windows_Font.Items.Indexof( Current_Font ) ;
end ;


procedure TVideo_Options_Dialog.Browse_ButtonClick(Sender: TObject);

begin
    if( OpenDialog1.Execute ) then
    begin
        Filename.Text := OpenDialog1.Filename ;
    end ;
end ;


end.
